
define(function(require, exports) {
	//公用类
	var common = require('common');
	//侧栏菜单
	var leftmenu = require('leftmenu');
	//用户ID
	var locuserid = localStorage.getItem('userid');
	//筛选的分类
	var audiovisualType = localStorage.getItem('audiovisualType');

	var listen = function(e, id, page) {

		this.page = page; //页面

		this.lantype = page.find(".lantype");

		this.buttonsTab = page.find(".buttons-tab");
		
		this.audiovisual = page.find("#audiovisual");

		//侧栏菜单
		if(locuserid == null) {
			this.page.find('.open-panel').on('click', function() {
				$.toast('更多功能在登录之后回来');
				setTimeout(function() {
					$.router.load('../index.html');
				}, 3000);
			});
		} else {
			leftmenu.showmenu(this.page);
		}

		//页面加载
		this.PageLoad();
	};

	//页面加载
	listen.prototype.PageLoad = function() {
		var that = this, params={};
       console.log(audiovisualType);
		//扩展练习：type = 0，数字教材：type = 1
		//英语：lantype = 0,日语：lantype = 1,韩语：lantype = 2
		if(audiovisualType != null){
			params = JSON.parse(audiovisualType);
			var type = params.type;
			var lantype = params.lantype;
			that.buttonsTab.find('a').removeClass('active');
			that.buttonsTab.find('a[type="'+type+'"]').addClass('active');
			that.lantype.find('span').removeClass('active');
			that.lantype.find('li[lantype="'+lantype+'"]').find('span').addClass('active');
		}
		else{
			 params = {
			type: 0,
			lantype: 0
		};
		}
		//加载数据
		that.loadDatas(params);
		//点击分类
		that.choosetype();
	};

	listen.prototype.loadDatas = function(params) {
		var that = this,html = [];		
		var baseUrl = localStorage.getItem('base');
		common.get('/showAllBook.html',params, function(res) {
			console.log(res)
			if(res.rows.length > 0) {
				for(var i = 0; i < res.rows.length; i++) {
					html.push('<li><a class="item-link item-content" href="listenUnit.html?audiovisualId='+res.rows[i].id+'">');
					html.push('<div class="item-media"><img src="'+ baseUrl + res.rows[i].imgUrl+'" width="140"></div>');
					html.push('<div class="item-inner m_t_10"><div class="item-text">'+res.rows[i].name+'</div><div class="item-text">'+res.rows[i].authorName+'</div></div></a></li>');
				}
			}
			else{
				html.push('<div class="nomsg">暂无此分类教材</div>');
			}
			$("#audiovisual").html(html.join(''));
		})
	}

	listen.prototype.choosetype = function() {
		var that = this,type,lantype;
			if(audiovisualType != null){
			params = JSON.parse(audiovisualType);
			 type = params.type;
			 lantype = params.lantype;
		}
		else{
			 params = {
			type: 0,
			lantype: 0
		};
		}
		that.buttonsTab.find('a').off('click').on('click', function() {
			that.buttonsTab.find('a').removeClass('active');
			$(this).addClass('active');
			 type = $(this).attr('type');
			var params = {
				type: type,
				lantype: lantype
			};
			localStorage.setItem('audiovisualType',JSON.stringify(params));
			//加载数据
			that.loadDatas(params);
		})
		
		that.lantype.find('li').off('click').on('click', function() {
			that.lantype.find('li').find('span').removeClass('active');
			$(this).find('span').addClass('active');
		    lantype = $(this).attr('lantype');
			var params = {
				type: type,
				lantype: lantype
			};
			localStorage.setItem('audiovisualType',JSON.stringify(params));
			//加载数据			
			that.loadDatas(params);

		})

	}


	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new listen(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};

});