define(function(require, exports) {

	//公用类
	var common = require('common');

	//播放组件
	var item = function(e, id, page) {
		this.page = page; //页面
		this.player = {
			playList: null,
			length: 0,
			$this: null,
			currentIndex: 0,
			current: null,
			canvas: null,
			backImage: null,
			isPlaying: false,
			playbackRate: 1,
			mode: 0
		};
		this.controls = {};
		this.init();
	};
	var shouldplay;
	//初始化
	item.prototype.init = function() {
		var _this = this;
		$(document).ready(function() {
			function UrlSearch() {
				var name, value;
				var str = location.href; //取得整个地址栏
				var num = str.indexOf("?")
				str = str.substr(num + 1); //取得所有参数   stringvar.substr(start [, length ]
				var arr = str.split("&"); //各个参数放到数组里
				for(var i = 0; i < arr.length; i++) {
					num = arr[i].indexOf("=");
					if(num > 0) {
						name = arr[i].substring(0, num);
						value = arr[i].substr(num + 1);
						this[name] = value;
					}
				}
			}

			var Request = new UrlSearch(); //实例化
			var params = {
				bookid: Request.audiovisualId,
				unitid: Request.unitId
			}
			shouldplay = Request.taskid;
			$("#btnback").prop('href', 'listenWords.html?audiovisualId=' + Request.audiovisualId + '&unitId=' + Request.unitId + '')
			var mp3 = null;
			var baseUrl = localStorage.getItem('base');
			var baseURL = localStorage.getItem('base') + '/mobileMta';
			var url = "/findPractice.html";
//			if(Request.download == "Y") {
			//下载功能暂未接入
			if(1==2){
				var resData = localStorage.getItem('resData');
				console.log(resData);
				var resJson = JSON.parse(resData);
				$("#lrc_content").text(resJson.content);
				if(window.plus) {
					plusReady();
				} else {
					document.addEventListener("plusready", plusReady, false);
				}

				// H5 plus事件处理
				function plusReady() {
					// 获取音频目录对象
					plus.io.resolveLocalFileSystemURL("_downloads/listenAndRead" + Request.id + ".mp3", function(entry) {
						if(entry) {
							mp3 = plus.io.convertLocalFileSystemURL(entry.toURL());
							jplayerPlay(mp3);
						}
					}, function(e) {

					});
				}
			} else {
				$.ajax({
					type: 'GET',
					url: baseURL + url,
					cache: false,
					data: params,
					success: function(res) {
						
						var data = JSON.parse(res);
						var musiclist;
						var splaylist = [];
						var sum = 0;						
						for(var j = 0; j < data.audiovisual[0].part.length; j++) {
							musiclist = data.audiovisual[0].part[j].task;
//							console.log(musiclist)
							for(var i = 0; i < musiclist.length; i++) {
								splaylist.push({});
								splaylist[sum].id = musiclist[i].id;
								splaylist[sum].name = musiclist[i].name;
								splaylist[sum].src = localStorage.getItem('base') + musiclist[i].screen;
								splaylist[sum].cover = "";
								splaylist[sum].singer = "";
								splaylist[sum].duration = "";
								splaylist[sum].lyric = musiclist[i].content;
								splaylist[sum].index = i;
								sum++;
							}
						}

						function isHasElementOne(arr, value) {
							for(var i = 0, vlen = arr.length; i < vlen; i++) {
								if(arr[i].id == value) {
									return i;
								}
							}
						}
						shouldplay = isHasElementOne(splaylist, shouldplay);
						//						console.log(shouldplay);
						//						console.log(splaylist);
						_this.load(splaylist);
					}
				})
			}
		});
	};

	//页面加载
	item.prototype.load = function(playlist) {
		this.controls.btnLoopMode = $('#btnLoopMode');
		this.controls.btnPlay = $('#btnPlay');
		this.controls.btnPrev = $('#btnPrev');
		this.controls.btnNext = $('#btnNext');
		this.controls.btnFastForward = $('#btnFastForward');
		this.controls.btnFastBackward = $('#btnFastBackward');
		this.controls.btnList = $('#btnList');
		this.controls.coverPanel = $('#coverPanel');
		this.controls.listPanel = $('#listPanel');
		this.controls.btnListPanelClose = $('#btnListPanelClose');
		this.controls.panelHeaderTitle = $('#panelHeaderTitle');
		this.controls.lrcPanel = $('#lrcPanel');
		this.controls.process = $('#process');
		this.controls.currentTime = $('#currentTime');
		this.controls.processBar = $('#processBar');
		this.controls.processBg = $('#processBg');
		this.controls.processPass = $('#processPass');
		this.controls.indicator = $('#indicator');
		this.controls.totalTime = $('#totalTime');

		this.player.$this = document.createElement("audio");
		this.player.$this.controls = false;
		// this.player.$this.volume = 0.1;

		this.player.playList = playlist;
		this.player.length = playlist.length;
		this.player.currentIndex = shouldplay;
		this.player.isPlaying = false;

		this.bindEvent();
		this.renderList();
		this.mode();
		this.resetCursor();
		this.play();

	};

	function getElementByAttr(tag, attr, value) {
		var aElements = document.getElementsByTagName(tag);
		var aEle = [];
		for(var i = 0; i < aElements.length; i++) {
			if(aElements[i].getAttribute(attr) == value)
				aEle.push(aElements[i]);
		}
		return aEle;
	}

	//绑定事件
	item.prototype.bindEvent = function() {
		var that = this;
		//切换模式
		this.controls.btnLoopMode.off('click').on('click', function() {
			that.player.mode++;
			if(that.player.mode === 3) {
				that.player.mode = 0;
			}
			$(that.player.$this)[0].loop = false;
			if(that.player.mode === 1) {
				$(that.player.$this)[0].loop = true;
			}
			that.mode();
		});

		//播放按钮
		this.controls.btnPlay.off('click').on('click', function() {
			if(that.player.isPlaying) {
				that.pause();
			} else {
				that.play();
			}
		});

		//上一曲
		this.controls.btnPrev.off('click').on('click', function() {
			that.prev();
		});

		//下一曲
		this.controls.btnNext.off('click').on('click', function() {
			that.next();
		});

		//快进
		this.controls.btnFastForward.off('click').on('click', function() {
			that.player.playbackRate += 0.5;
			that.playbackRate();
		});

		//快退
		this.controls.btnFastBackward.off('click').on('click', function() {
			that.player.playbackRate -= 0.5;
			if(that.player.playbackRate === 0)
				that.player.playbackRate = -0.5;
			that.playbackRate();
		});

		//点击进度条事件
		this.controls.processBar.click(function(e) { //鼠标点击
			var w = that.controls.processBar.width();
			var l = e.pageX - that.controls.processBar.offset().left;
			if(l < 0) return;
			if(l > w) return;
			that.process(l / w);
			e.preventDefault();
		});

		//拖动指示器事件
		this.controls.indicator.off('touchmove').on('touchmove', function(e) {
			var x = e.touches[0].clientX;
			var w = that.controls.processBar.width();
			var l = x - that.controls.processBar.offset().left;
			if(l < 0) return;
			if(l > w) return;
			that.process(l / w);
			e.preventDefault();
		});

		//列表切换显示
		this.controls.btnList.off('click').on('click', function() {
			that.controls.listPanel.removeClass('hide').addClass('show');
		});

		//关闭列表
		this.controls.btnListPanelClose.off('click').on('click', function() {
			that.controls.listPanel.removeClass('show').addClass('hide');
		});

		//点击列表选项
		that.controls.listPanel.off('click').on('click', function(e) {
			if(e.target.tagName === 'LI') {
				that.resetCursor(e.target);
				//				console.log(e.target)
			}
			if(e.target.tagName === 'A') {
				//				console.log(e.target)
				if(!$(e.target).hasClass('remove-item')) return false;
				var targetItem = $(e.target).parent();
				var index = targetItem.attr('data-index');
				var tar = that.player.playList[index];
				tar.status = 'del';
				targetItem.remove();
				that.remove(tar);
			}
		});

		//结束
		that.player.$this.addEventListener('ended', function(e) {
			//console.log('onended');
			if(that.player.mode !== 1) { //不是单曲
				that.next();
			}
		});

		//播放过程
		that.player.$this.addEventListener('timeupdate', function(e) {
			var currentTime = that.player.$this.currentTime;
			that.controls.currentTime.html(that.setTime(currentTime));
			that.listenProcess(currentTime);
		});

		//加载完成
		that.player.$this.addEventListener('loadedmetadata', function(e) {
			that.controls.currentTime.html('00:00');
			while(true) {
				if(!isNaN(that.player.$this.duration)) {
					that.controls.totalTime.html(that.setTime(that.player.$this.duration));
					break;
				}
			}
		});

		//歌词点击
		this.controls.lrcPanel.off('click').on('click', function(e) {
			if(e.target.tagName === 'P') {
				that.player.$this.currentTime = e.target.dataset.time;
				that.listenProcess(e.target.dataset.time);
			}
		});

		//移除歌曲
	};

	//格式化日期
	item.prototype.setTime = function(s) {
		var second = parseInt(s, 10); // 秒
		var min = 0; // 分
		var hour = 0; // 小时
		if(second >= 60) {
			min = parseInt(second / 60);
			second = parseInt(second % 60);
			if(min >= 60) {
				hour = parseInt(min / 60);
				min = parseInt(min % 60);
			}
		}

		if(second < 10) {
			var result = "0" + parseInt(second);
		} else {
			var result = parseInt(second);
		}

		if(min > 0) {
			result = parseInt(min) + ":" + result;
			if(min < 10) {
				var result = "0" + result;
			}
		} else if(min === 0) {
			result = "00:" + result;
		}

		if(hour > 0) {
			result = parseInt(hour) + ":" + result;
		}
		return result;
	};

	//获取时间
	item.prototype.getTime = function(timer) {
		var s = 0;
		if(timer) {
			var timerArray = timer.split(':');
			var hour, min, sen;
			if(timerArray.length === 3) {
				hour = parseInt(timerArray[0], 10);
				min = parseInt(timerArray[1], 10);
				sen = parseInt(timerArray[2], 10);
				s = hour * 3600 + min * 60 + sen;
			} else if(timerArray.length === 2) {
				min = parseInt(timerArray[0], 10);
				sen = parseInt(timerArray[1], 10);
				s = min * 60 + sen;
			} else if(timerArray.length === 1) {
				sen = parseInt(timerArray[0], 10);
				s = sen;
			}
		}
		return s;
	};

	//更新进度
	item.prototype.process = function(p) {
		var duration = this.player.$this.duration;
		var w = this.controls.processBar.width();
		this.player.$this.currentTime = duration * p;
		this.controls.processPass.width(w * p);
	};

	//监听进度
	item.prototype.listenProcess = function(p) {
		var duration = this.player.$this.duration;
		var w = this.controls.processBar.width();
		this.controls.processPass.width(w * (p / duration));
		this.scrollLrc(p);
	};

	//设置歌词滚动
	item.prototype.scrollLrc = function(p) {
		var target = this.controls.lrcPanel.find('p[data-time="' + parseInt(p, 10) + '"]');
		//本来的
		if(target && target.length > 0) {
			var currentLine = this.controls.lrcPanel.find('.current');
			if(currentLine !== target) {
				currentLine.removeClass('current');
				target.addClass('current');
				this.scrollLrc(target);
			}

			var keepTop = this.controls.lrcPanel.height() / 2;
			var passTop = target.get(0).offsetTop - keepTop;
			if(passTop < 0) {
				passTop = 0;
			}
			this.controls.lrcPanel.scrollTop(passTop);
		}

		//		//修改版
		//		var datas = $(".lrcone");
		//		//比较数组
		//		var timearr = [];
		//		var nowtime = parseInt(p, 10);
		//		for(var i = 0; i < datas.length; i++) {
		//			var timeone = $(datas[i]).attr("data-time");
		//			if(timeone < nowtime) {
		//				timearr.push(timeone)
		//			}
		//		}
		//		var thelast = timearr[timearr.length - 1];
		//		var nowp;
		//		
		//		if(thelast) {			
		//			//当前播放的p标签
		//			$(".current").removeClass('current');
		//			nowp = $("p[data-time$='" + thelast + "']");
		//			nowp.addClass('current');
		//		}
		//		var keepTop = this.controls.lrcPanel.height() / 2;
		//		var passTop = nowp.offset().top - keepTop;
		//		console.log(nowp.offset().top)
		//		if(passTop < 0) {
		//			passTop = 0;
		//		}
		//		this.controls.lrcPanel.scrollTop(passTop);
	};

	//充值指针
	item.prototype.resetCursor = function(obj) {
		var targetItem = $(obj);
		if(obj) {
			this.player.currentIndex = targetItem.attr('data-index');
		} else {
			targetItem = this.controls.listPanel.find('li').eq(this.player.currentIndex);
		}
		this.player.current = this.player.playList[this.player.currentIndex];
		if(this.player.current === null || this.player.current === undefined) return;
		if(this.player.current.status === 'del') {
			this.next();
		}
		this.player.$this.pause();
		this.player.$this.src = this.player.current.src;
		this.player.playbackRate = 1;
		this.player.$this.playbackRate = this.player.playbackRate;
		this.player.$this.defaultPlaybackRate = this.player.playbackRate;
		this.player.$this.load();
		var currentItem = this.controls.listPanel.find('.item-status');
		if(currentItem !== targetItem) {
			currentItem.remove();
			targetItem.prepend('<span class="item-status"><i class="fa fa-play"></i></span>');
		}
		this.renderLyc(this.player.current.lyric);
		if(this.player.isPlaying) {
			this.play();
		}
	};

	//播放
	item.prototype.play = function() {
		this.controls.btnPlay.html('<i class="fa fa-pause"></i>');
		this.player.isPlaying = true;
		this.player.$this.play();
		//console.log(this.player.current)
		$(".bar h1.title").html(this.player.current.name);
	};

	//暂停
	item.prototype.pause = function() {
		this.controls.btnPlay.html('<i class="fa fa-play"></i>');
		this.player.isPlaying = false;
		this.player.$this.pause();
		console.log('暂停');
	};

	//上一曲
	item.prototype.prev = function() {
		if(this.player.mode === 2) { //随机
			this.player.currentIndex = this.random();
		} else {
			if(this.player.currentIndex === 0) {
				this.player.currentIndex = this.player.length;
				return false;
			} else {
				this.player.currentIndex--;
			}
		}
		this.resetCursor();
	};

	//下一曲
	item.prototype.next = function() {
		if(this.player.mode === 2) { //随机
			this.player.currentIndex = this.random();
		} else if(this.player.mode === 0) {
			if(this.player.currentIndex === this.player.length - 1) {
				this.player.currentIndex = 0;
			} else {
				this.player.currentIndex++;
			}
		}
		this.resetCursor();
		//		console.log(this.player)
	};

	//模式切换
	item.prototype.mode = function() {
		var icon = '';
		var iconText = '';
		switch(this.player.mode) {
			case 0: //列表播放
				icon = 'fa-list-ul';
				iconText = '列表播放';
				break;
			case 1: //单曲循环
				icon = 'fa-long-arrow-right';
				iconText = '单曲循环';
				break;
			case 2: //随机播放
				icon = 'fa-random';
				iconText = '随机播放';
				break;
		}
		common.toast(iconText);
		this.controls.btnLoopMode.html('<i class="fa ' + icon + '"></i>');
		this.controls.panelHeaderTitle.html('<i class="fa ' + icon + '"></i>' + iconText + '(' + this.player.length + ')');
	};

	//绘制播放列表
	item.prototype.renderList = function() {
		var container = this.controls.listPanel.find('.panel-body');

		var html = [];

		for(var i = 0, len = this.player.length; i < len; i++) {
			var m = this.player.playList[i];
			console.log(m)
			//<a class="remove-item">×</a>删除按钮 在下一行的最后的li内'<a class="remove-item">×</a></li>'
			html.push('<li data-index="' + i + '" data-id="' + m.id + '" data-name="' + m.name + '" data-src="' + m.src + '" data-cover="' + m.cover + '" data-lyric="' + m.lyric + '" data-singer="' + m.singer + '">' + m.name + '</li>');
		}

		container.html(html.join(''));
	};

	//绘制歌词
	item.prototype.renderLyc = function(lrc) {
		//TODO：加载歌词文件
		var lyc = '[00:00.00] 作曲 : John Laudon\n' +
			'[00:01.00] 作词 : 潘伟源\n' +
			'[00:35.000]她熄掉晚灯 幽幽掩两肩\n' +
			'[00:39.000]交织了火花 拘禁在沉淀\n';
		if(lrc) {
			lyc = lrc
		}
		//		console.log(lyc)
		var lycArrays = lyc.split('\n');
		var lycArray = [];
		for(var i = 0; i < lycArrays.length; i++) {
			if(lycArrays[i].length == 1) {

			} else {
				lycArray.push(lycArrays[i])
			}
		}
		//		console.log(lycArray)
		var html = [];
		for(var i = 0, len = lycArray.length; i < len; i++) {
			var txt = lycArray[i];
			//			var timeSpan = txt.match(/\[.*\]/gi)[0];
			//			console.log(timeSpan)
			//			var t = txt.replace(timeSpan, '');
			//			console.log(t)
			//			var time = timeSpan.replace(/\[|\]|\.\d+/gi, '');
			//			console.log(time)
			//			var tt = this.getTime(time);
			var timeSpan = txt.match(/\[.+?\]/)[0];
			//						console.log(timeSpan)
			var t = txt.replace(timeSpan, '');
			//			console.log(t)
			var time = timeSpan.replace(/\[|\]|\.\d+/gi, '');
			//			console.log(time)
			var tt = this.getTime(time);
			//			console.log(tt)
			html.push('<p class="lrcone" data-time="' + tt + '" data-index="' + i + '">' + t + '</p>');
		}
		//		console.log(html)
		this.controls.lrcPanel.html(html.join(''));
	};

	//随机
	item.prototype.random = function() {
		var index;
		var len = this.player.length;
		while(true) {
			index = Math.floor(Math.random() * (len));
			if(index !== len && index !== this.player.currentIndex) {
				break;
			}
		}
		return index;
	};

	//添加歌曲
	item.prototype.add = function() {

	};

	//移除歌曲
	item.prototype.remove = function(obj) {
		this.player.length--;
		this.mode();
	};

	//清空列表
	item.prototype.clear = function() {
		this.player.length = 0;
		this.player.currentIndex = 0;
		this.player.playList = [];
		this.controls.listPanel.empty();
		this.mode();
	};

	//设置播放速度
	item.prototype.playbackRate = function() {
		common.toast('播放速度：' + this.player.playbackRate);
		this.player.$this.playbackRate = this.player.playbackRate;
		this.player.$this.defaultPlaybackRate = this.player.playbackRate;
	};

	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new item(e, id, $page);
		} else {
			$page.data('page', obj);
		}

		return obj;
	};
});