/**
 * Created by X01 on 2016-06-08.
 */
define(function(require, exports) {
	//公用类
	var common = require('common');

	var register = function(e, id, page) {
		this.page = page; //页面

		//用户名
		this.username = page.find('#username');
		//密码
		this.userpwd = page.find('#userpwd');
		//注册按钮
		this.btnregister = page.find('#btnregister');
		//协议勾选框
		this.protocol = page.find('#protocol');

		//省份内容
		this.provinceList = page.find('#provinceList');

		//城市内容
		this.cityList = page.find('#cityList');

		$(document).on("click", '.icon-menu', function() {
			$.openPanel("#panel-screen");
		});

		//注册按钮点击事件
		this.btnregist();

		//加载省份
		this.loadProvince();
		
		//加载院校界别
		this.loadSchoolType();

	};

	//注册按钮点击事件
	register.prototype.btnregist = function() {
		var that = this;
		var numError = that.validate();
		that.btnregister.off('click').on('click', function() {			
			if(!(/^1(3|4|5|7|8)\d{9}$/.test($("#tel").val()))){
				$.toast("请填写正确的手机号");
				return;
			}
			if(that.protocol.is(':checked')) {
				if(localStorage.getItem('base')) {
					baseURL = localStorage.getItem('base') + '/mobileMta';
                    var username = that.username.val();
                    var pwd = that.userpwd.val();
                    var email = $("#email").val();
                    var province = $("#province").val();
                    var city = $("#city").val();
                    var schoolname = $("#schoolName").val();
                    var level = $("#level").val();
                    var qq = $("#qq").val();
                    var phone = $("#tel").val();
/*                   var params = "username: "+username+",pwd: "+pwd+"";*/
                 /* if(email != ""){
                    	params +=",email:"+email;
                    }
                  if(province != ""){
                    	params +=",province:"+province;
                    }
                   if(city != ""){
                    	params +=",city:"+city;
                    }
                    
                     if(schooltype != ""){
                    	params +=",schooltype:"+schooltype;
                    }
                       if(level != ""){
                    	params +=",level:"+level;
                    }
                         if(qq != ""){
                    	params +=",qq:"+qq;
                    }
                           if(phone != ""){
                    	params +=",phone:"+phone;
                    }*/
					common.post('/registUser.html', {
						username : username,
						pwd:pwd,
						email:email,
						province:province,
						city:city,
						schoolname:schoolname,
						level:level,
						qq:qq,
						tel:phone
					}, function(res) {
                  
						if(numError) {
							return false;
						}
						switch(res.res) {
							case 0:
								$.toast('注册失败');
								break;
							case 1:
								$.toast('注册成功');
								that.userinfo(res.loginUser);
								$.router.load('../course/list.html');
								break;
							case -2:
								$.toast('用户名不能为空');
								break;
							case -3:
								$.toast('密码不能为空');
								break;
							case -4:
								$.toast('用户名已注册');
								break;
						}
					});
				} else {
					$.toast('请填写服务器地址');
				}
			} else {
				$.toast('注册需要同意用户协议')
			}
		});
	};

	//缓存用户信息
	register.prototype.userinfo = function(data) {
		localStorage.setItem('userid', data.userid);
		localStorage.setItem('tel', data.tel);

		if(data.icon) {
			localStorage.setItem('usericon', data.icon);
		} else {
			localStorage.setItem('usericon', '../../img/logo.jpg');
		}
		localStorage.setItem('nickname', data.nickname);
		localStorage.setItem('realname', data.realname);

		if(data.gender) {
			localStorage.setItem('gender', '男');
		} else {
			localStorage.setItem('gender', '女');
		}

		localStorage.setItem('qq', data.qq);
		localStorage.setItem('birthdayStr', data.birthdayStr);
		localStorage.setItem('address', data.address);
		localStorage.setItem('groupid', data.groupid);
		localStorage.setItem('interest', data.interest);

		if(data.vipEndTime != null) {
			var today = new Date().Format('yyyy-MM-dd');
			var arr = today.split("-");
			var todaytime = new Date(arr[0], arr[1], arr[2]);
			var todaytimes = todaytime.getTime();

			var arrs = data.vipEndTime.split("-");
			var viptime = new Date(arrs[0], arrs[1], arrs[2]);
			var viptimes = viptime.getTime();

			if(todaytimes <= viptimes) {
				localStorage.setItem('vip', 'true');
			} else {
				localStorage.setItem('vip', 'false');
			}
		} else {
			localStorage.setItem('vip', 'false');
		}
	};

	//验证
	register.prototype.validate = function() {
		var that = this;
		//文本框失去焦点后
		$('div[id="register"]').find('input').blur(function() {
			var $parent = $(this).parent();
			$parent.find(".formtips").remove();
			//验证用户名
			if($(this).is('#username')) {
				if(this.value == "") {
					var errorMsg = '用户名不可以为空';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
					$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
				}
			}
			//验证邮件
			if($(this).is('#email')) {
				if(this.value == "" || (this.value != "" && !/.+@.+\.[a-zA-Z]{2,4}$/.test(this.value))) {
					var errorMsg = '填入正确E-Mail地址.';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
					$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
				}
			}
			//验证密码
			if($(this).is('#userpwd')) {
				if(this.value == "") {
					var errorMsg = '密码不能为空';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
					$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
				}
			}
			//验证确认密码
			if($(this).is('#userpwd2')) {
				var password = $('#userpwd').val();
				if(this.value == "" || (this.value != password)) {
					var errorMsg = '两次密码不一致';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
					$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
				}
			}
			//验证手机号
			if($(this).is('#tel')) {
				if(this.value == ""){
					var errorMsg = '手机号必填';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				}
				else{
					if(!(/^1(3|4|5|7|8)\d{9}$/.test($("#tel").val()))) {
					var errorMsg = '请输入正确手机号';
					$parent.append('<span class="formtips onError">' + errorMsg + '</span>');
				} else {
					var okMsg = '<span style="color:#009933" class="icon-normal"></span>';
					$parent.append('<span class="formtips onSuccess">' + okMsg + '</span>');
				}
				}
			
				
			}
		}).keyup(function() {

			$(this).triggerHandler("blur");
			var numError = $('form .onError').length;
		}).focus(function() {
			$(this).triggerHandler("blur");
		}); //end blur

	}

	//加载省份
	register.prototype.loadProvince = function() {
		var that = this,provinceId;
		$('#chooseProvince').off('click').on('click',function(){
			$('#provinceDiv').show();
			$("#cityDiv").hide();
			$("#schoolType").hide();
		})
		common.get('/getAllProvince.html', function(res) {
			var html = [];
			for(var i = 1; i < res.length; i++) {
				html.push('<li class="item-content">' + res[i].provincename + '</li>')
			}
			$(provinceList).html(html.join(''));
			$("#provinceList li").off('click').on('click', function() {
				 provinceId = $(this).index()+1;
				var provinceName = $(this).text();
				$("#province").val(provinceName);
				$("#city").val("");
				$('#provinceList li').removeClass('active');
				$(this).addClass('active');				
			});
			$('#btnscr').off('click').on('click', function() {
				$("#provinceDiv").hide();
				$("#cityDiv").show();
				that.loadCity(provinceId);
			});

		});

	}
	register.prototype.loadCity = function(provinceId){
		var params = {provinceid:provinceId};
		
		common.get('/getCityByProvinceId.html', params,function(res) {
			var html = [];
			for(var i = 1; i < res.length; i++) {
				html.push('<li class="item-content">' + res[i].cityname + '</li>')
			}
			$("#cityList").html(html.join(''));
			$("#cityList li").off('click').on('click', function() {
				var cityName = $(this).text();
				$("#city").val(cityName);
				$('#cityList li').removeClass('active');
				$(this).addClass('active');
			
			});
		
			$('#closeBtn').off('click').on('click',function(){
				$("#provinceDiv").show();
				$("#cityDiv").hide();
			});
		
		});
	}


    
	//加载院校级别
	register.prototype.loadSchoolType = function(){
		var that = this;
		$('#schoolLevel').off('click').on('click',function(){
			$('#provinceDiv').hide();
			$("#cityDiv").hide();
			$("#schoolType").show();
		})
		common.get('/getAllType.html',function(res) {
			var html = [];
			for(var i = 1; i < res.length; i++) {
				html.push('<li class="item-content">' + res[i].schoolTypename + '</li>')
			}
			$("#schoolTypeList").html(html.join(''));
			$("#schoolTypeList li").off('click').on('click', function() {
				var schoolType = $(this).text();
				$("#level").val(schoolType);
				$('#schoolTypeList li').removeClass('active');
				$(this).addClass('active');
			
			});
		
		});
		
	}
	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new register(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};
})