/**
 * Created by X01 on 2016-06-08.
 */
define(function (require, exports) {

    //公用类
    var common = require('common');

    //用户ID
    var locuserid = localStorage.getItem('userid');
    //用户名
    var locnickname = localStorage.getItem('nickname');
    //真实姓名
    var locrealname = localStorage.getItem('realname');
    //性别
    var locgender = localStorage.getItem('gender');
    //生日
    var locbirthdayStr = localStorage.getItem('birthdayStr');
    //邮箱
    var locemail = localStorage.getItem('email');
    //电话
    var loctel = localStorage.getItem('tel');

    var data = {userid: locuserid};

    //修改类型
    var type = window.location.href.split('=')[1];

    var edit = function (e, id, page) {
        this.page = page;

        //标题栏文本
        this.edittitle = page.find('#edittitle');
        //输入框
        this.editinput = page.find('#editinput');
        //输入框清空按钮
        this.btnclear = page.find('.btnclear');
        //信息保存
        this.btnsave = page.find('#btnsave');
        //性别选择列表
        this.genderlist = page.find('#genderlist');

        //页面加载
        this.PageLoad(type);

        //信息保存
        this.infochange();
    };

    //页面加载
    edit.prototype.PageLoad = function (type) {
        var that = this;

        that.editinput.parent().addClass('hidden');
        that.genderlist.addClass('hidden');

        switch (type) {
            case 'nickname':
                that.edittitle.text('用户名');
                if (locnickname && locnickname != 'null' && locnickname != 'undefined') {
                    that.editinput.val(locnickname);
                }
                that.editinput.parent().removeClass('hidden');
                break;
            case 'realname':
                that.edittitle.text('真实姓名');
                if (locrealname && locrealname != 'null' && locrealname != 'undefined') {
                    that.editinput.val(locrealname);
                }
                that.editinput.parent().removeClass('hidden');
                break;
            case 'gender':
                that.edittitle.text('性别');
                that.genderlist.removeClass('hidden');
                break;
            case 'birthdayStr':
                that.edittitle.text('生日');
                if (locbirthdayStr && locbirthdayStr != 'null' && locbirthdayStr != 'undefined') {
                    that.editinput.val(locbirthdayStr);
                }
                that.editinput.parent().removeClass('hidden');
                that.infoPicker();
                break;
            case 'email':
                that.edittitle.text('邮箱');
                if (locemail && locemail != 'null' && locemail != 'undefined') {
                    that.editinput.val(locemail);
                }
                that.editinput.parent().removeClass('hidden');
                break;
            case 'tel':
                that.edittitle.text('电话');
                if (loctel && loctel != 'null' && loctel != 'undefined') {
                    that.editinput.val(loctel);
                }
                that.editinput.parent().removeClass('hidden');
                break;
            case 'repwd':
                that.edittitle.text('修改密码');
                that.editinput.val('');
                that.editinput.parent().removeClass('hidden');
                break;
        }

        switch (locgender) {
            case '男':
                that.genderlist.find('li').eq(0).addClass('active');
                break;
            case '女':
                that.genderlist.find('li').eq(1).addClass('active');
                break;
        }

        that.btnclear.off('click').on('click', function () {
            that.editinput.val('').focus();
            that.btnclear.addClass('hidden');
        });

        that.btnclear.prev().off('keyup').on('keyup', function () {
            if (that.btnclear.prev().val().length == 0) {
                that.btnclear.addClass('hidden');
            } else {
                that.btnclear.removeClass('hidden');
            }
        });

        that.genderlist.find('li').off('click').on('click', function () {
            that.genderlist.find('li').removeClass('active');
            $(this).addClass('active');
        });

        if (that.btnclear.prev().val().length == 0) {
            that.btnclear.addClass('hidden');
        } else {
            that.btnclear.removeClass('hidden');
        }
    };

    edit.prototype.infochange = function () {
        var that = this;

        that.btnsave.off('click').on('click', function () {
            if (type == 'gender') {
                var idx = that.genderlist.find('.active').index();

                if (idx == 0) {
                    data[type] = true;
                } else if (idx == 1) {
                    data[type] = false;
                }
console.log(data);
                common.post('/updUser.html', data, function (res) {
                    if (res.gender) {
                        localStorage.setItem('gender', '男');
                    } else {
                        localStorage.setItem('gender', '女');
                    }

                    $.router.load('me.html');
                });
            } else {
            	console.log(data);
                data[type] = that.editinput.val();

                common.post('/updUser.html', data, function () {
                    localStorage.setItem(type, that.editinput.val());

                    $.router.load('me.html');
                });
            }
        });
    };

    edit.prototype.infoPicker = function () {
        var that = this;

        var Years = [];
        var Mons = [];
        var Days = [];
        var mons, days;

        //计算前后年份
        var year = new Date().Format('yyyy');
        for (var y = 0; y < 60; y++) {
            Years.push(year - 30 + y);
        }

        for (var m = 1; m < 13; m++) {
            mons = m.toString().padLeft(2, '0');
            Mons.push(mons);
        }

        for (var d = 1; d < 32; d++) {
            days = d.toString().padLeft(2, '0');
            Days.push(days);
        }

        that.editinput.picker({
            toolbarTemplate: '<header class="bar bar-nav">' +
            '<button class="button button-link pull-right close-picker">确定</button>' +
            '<h1 class="title">选择生日</h1>' +
            '</header>',
            cols: [{
                textAlign: 'center',
                values: Years
            }, {
                textAlign: 'center',
                values: Mons
            }, {
                textAlign: 'center',
                values: Days
            }],
             onClose: function (picker) {
            	//没有选择就是默认值
            	var Y;
            	var M;
            	var D;
            	if (typeof(picker.cols[0].value)=="undefined"){
            		Y=year-30;
            	}else{
            		Y=picker.cols[0].value;
            	}
            	if (typeof(picker.cols[1].value)=="undefined"){
            		M='01';
            	}else{
            		M=picker.cols[1].value;
            	}
            	if (typeof(picker.cols[2].value)=="undefined"){
            		D='01';
            	}else{
            		D=picker.cols[2].value;
            	}
            	that.editinput.val(Y + '-' + M + '-' + D);
            	
            	
//              if (picker.cols[0].value && picker.cols[1].value && picker.cols[2].value) {
//                  
//                  that.btnsave.removeClass('hidden');
//              } else {
//                  $.toast('请选择正确的日期');
//              }
            }
        });
    };

    exports.init = function (e, id, page) {

        var $page = $(page);

        var obj = $page.data('page');

        if (!obj) {
            obj = new edit(e, id, $page);
        } else {
            $page.data('page', obj);
        }
        return obj;
    };
});