define(function(require, exports) {

	//公用类
	var common = require('common');
	//菜单
	//var menu = require('menu');
	//获取用户ID
	var locuid = localStorage.getItem('userid');

	var meour = function(e, id, page) {
		this.page = page; //页面

		//tab标签
		this.tabview = page.find('.tabview');
		//tab内容
		this.tabcontent = page.find('.tabcontent');

		//总学分
		this.AllCredit = page.find('#AllCredit');
		//学分列表
		this.CreditList = page.find('#CreditList');

		//消息列表
		this.MesList = page.find('#MesList');

		//头像
		this.usericon = page.find('img.usericon');
		//头像修改
		this.userimg = page.find('#userimg');

		//用户名
		this.nickname = page.find('#nickname');
		//真实姓名
		this.realname = page.find('#realname');
		//性别
		this.gender = page.find('#gender');
		//生日
		this.birthdayStr = page.find('#birthdayStr');
		//年级
		this.groupid = page.find('#groupid');
		//邮箱
		this.email = page.find('#email');
		//电话
		this.tel = page.find('#tel');

		//退出登录
		this.logout = page.find('#logout');

		//页面加载
		this.PageLoad();

		//菜单
		//menu.showmenu(this.page, '4');
	};

	//页面加载
	meour.prototype.PageLoad = function() {
		var that = this;

		//学分
		common.get('/findMyCredit.html', {
			userid: locuid
		}, function(res) {
			var html = [];

			that.AllCredit.html('总学分：' + res.credit);

			for(var c = 0; c < res.total; c++) {
				var item = res.rows[c];

				html.push('<li class="row no-gutter">');
				html.push('<div class="col-20 label tipfont"><span>' + item.sorce + '</span>分</div>');
				html.push('<div class="col-80 tabcon">');
				if(item.kaoshiJson) {
					html.push('<span class="title">' + item.kaoshiJson + '</span>');
				} else {
					html.push('<span class="title">' + item.courseName + '</span>');
				}
				html.push('<span class="timer">' + item.insDate + '</span>');
				html.push('</div>');
				html.push('</li>');
			}

			that.CreditList.html(html.join(''));
		});

		//消息
		common.get('/findMesList.html', {
			userid: locuid
		}, function(res) {
			var html = [];

			that.MesList.html('总学分：' + res.credit);

			if(res.total == 0) {
				that.MesList.html('<div class="nomsg">还没有消息</div>');
			} else {
				for(var c = 0; c < res.total; c++) {
					var item = res.rows[c];

					html.push('<li class="item-content item-inner item-link" id="' + item.id + '">');
					html.push('<div class="item-title">' + item.msgcontent + '</div>');
					html.push('<div class="item-subtitle">' + item.sendtime + '</div>');
					html.push('</li>');
				}

				that.MesList.html(html.join(''));
			}
		});

		//设置
		common.get('/updUser.html', {
			userid: locuid
		}, function(res) {
			var base = localStorage.getItem('base');
			var userIcon = localStorage.getItem('usericon');

			//that.usericon.prop('src', userIcon || '../../img/logo.jpg');
			that.usericon.prop('src', base + userIcon)
			console.log(res)
			if(res.nickname) {
				that.nickname.text(res.nickname);
				that.page.find('.username').text(res.nickname);
				that.nickname.parents('.item-content')
					.attr('href', 'edit.html?type=nickname')
					.addClass('item-link');
			} else {
				that.nickname.parents('.item-content')
					.attr('href', 'edit.html?type=nickname')
					.addClass('item-link');
			}

			that.realname.text(res.realname);

			if(res.gender) {
				that.gender.text('男');
			} else {
				that.gender.text('女');
			}

			that.birthdayStr.text(res.birthdayStr);
			that.email.text(res.email);
			that.tel.text(res.tel);

		});

		//头像修改
		that.usericonchange();

		//分页切换
		/*	that.tabchange();*/

		//退出登录
		that.logout.off('click').on('click', function() {
			localStorage.clear();
			$.router.load('../../page/login/login.html');
		});
	}

	//头像修改
	meour.prototype.usericonchange = function() {
		var that = this;

		that.userimg.off('change').on('change', function() {
			var file = this.files[0];
			var reader = new FileReader();

			common.showloading();

			reader.readAsDataURL(file);
			reader.onload = function(e) {
				var img = new Image,
					width = 80, //图片resize宽度
					quality = 0.8, //图像质量
					canvas = document.createElement("canvas"),
					drawer = canvas.getContext("2d");
				img.src = this.result;
				canvas.width = width;
				canvas.height = width * (img.height / img.width);
				drawer.drawImage(img, 0, 0, canvas.width, canvas.height);
				canvas.toDataURL("image/*", quality);
				common.post('/saveUserHeadImage.html', {
					userid: locuid,
					pic: img.src.split(',')[1]
				}, function(res) {
					//							console.log('saveUserHeadImage.html' + JSON.stringify(res));
					if(res.userid == locuid) {
						var base = localStorage.getItem('base');
						//								console.log('icon:' + res.icon);
						that.usericon.prop('src', base + res.icon);
						localStorage.setItem('usericon', res.icon);
						common.hideloading();
						$.toast('头像修改成功');
					} else {
						$.toast('头像修改失败');
					}
				});
			}
		});

	}
	exports.init = function(e, id, page) {

		var $page = $(page);

		var obj = $page.data('page');

		if(!obj) {
			obj = new meour(e, id, $page);
		} else {
			$page.data('page', obj);
		}
		return obj;
	};

});